
#include <TROOT.h>
#include <TApplication.h>
#include <TGClient.h>
#include <TObject.h>
#include <TQObject.h>
#include <TGMenu.h>
#include <TGMdiMenu.h>
#include <TGFrame.h>
#include <TGMdiFrame.h>
#include <TGMdiMainFrame.h>
#include <TGStatusBar.h>
#include <TGListTree.h>
#include <TGStatusBar.h>
#include <TObjString.h>
#include <THashList.h>	
#include <TGSplitter.h>
#include <TGTab.h>

#include <TZMdiFrame.h>
#include <TZGlobal.h>


#ifndef TZ_TZMainFrame
#define TZ_TZMainFrame


class TZMainFrame : public TGMainFrame {
   private:
   TGMdiMainFrame *fMain; 
   TGPopupMenu *fMenuFile, *fMenuEdit, *fMenuView, *fMenuTools, *fMenuWindow, *fMenuHelp;
   TGLayoutHints *fMenuBarItemLayout, *fMenuBarHelpLayout;
   TGMdiMenuBar *fMenuBar;
   TGStatusBar *fStatusBar;
   void CloseWindow(); 	
   void AddNewMdiFrame();
   void CreateMenuFile();
   void CreateMenuEdit();
   void CreateMenuView();
   void CreateMenuTools();
   void CreateMenuWindow();
   void CreateMenuHelp();
   void EnableDisableMenus();
   void NewMenuItemActionPerformed();
   void OpenMenuItemActionPerformed();
   void CloseMenuItemActionPerformed();
   void SaveMenuItemActionPerformed();
   void SaveAsMenuItemActionPerformed();
   void PrintMenuItemActionPerformed();
   void PrintSetupMenuItemActionPerformed();
   void ExitMenuItemActionPerformed();
   void HandleMenu(Int_t id);
   public: 
    TZMainFrame (const TGWindow *p, UInt_t w, UInt_t h) ;
    virtual  ~TZMainFrame();
    	
   ClassDef(TZMainFrame, 0)

};   //end of class TZMainFrame



#endif

