#include <TZMdiFrame.h>

TZMdiFrame::TZMdiFrame (TGMdiMainFrame *mainFrame, const char* name, TGStatusBar *statusBar) 
   : TGMdiFrame(mainFrame, 900, 600, kHorizontalFrame)
 {	
   this->SetWindowName(name);

   fStatusBar = statusBar;
	  
   CreateMenuEdit();
	   
   TGVerticalFrame *vframe1 = new TGVerticalFrame(this, 10, 10, kFixedWidth);
      TGCanvas *canvasLeft = new TGCanvas(vframe1,102,364);
      TGViewPort *viewPortLeft = canvasLeft->GetViewPort();
        TGListTree *fGListTree = this->FillTree(canvasLeft);
      viewPortLeft->AddFrame(fGListTree, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY) );
      canvasLeft->SetContainer(fGListTree);
  vframe1->AddFrame(canvasLeft,new TGLayoutHints(kLHintsTop | kLHintsExpandX |kLHintsExpandY,0,0,5,5));
  vframe1->Resize(canvasLeft->GetDefaultWidth()+20, vframe1->GetDefaultHeight());
  this->AddFrame(vframe1,new TGLayoutHints(kLHintsLeft | kLHintsExpandY)); 
 
  TGVSplitter *splitter = new TGVSplitter(this,2,30); 
  splitter->SetFrame(vframe1, kTRUE);
   this->AddFrame(splitter,new TGLayoutHints(kLHintsLeft | kLHintsExpandY));  
    
  TGVerticalFrame *vframe2 = new TGVerticalFrame(this, 10, 10);
    TGTab *tabFrame = new TGTab(vframe2,376,364);
      TGCompositeFrame *nodeEditorFrame; nodeEditorFrame = tabFrame->AddTab("Node Editor");
      nodeEditorFrame->SetLayoutManager(new TGVerticalLayout(nodeEditorFrame));
      TGCompositeFrame *codeViewerFrame; codeViewerFrame = tabFrame->AddTab("Code");
      codeViewerFrame->SetLayoutManager(new TGVerticalLayout(codeViewerFrame));    
      TGCompositeFrame *dependencyFrame; dependencyFrame = tabFrame->AddTab("Dependencies");
      dependencyFrame->SetLayoutManager(new TGVerticalLayout(dependencyFrame));        
      TGCompositeFrame *resultsFrame; resultsFrame = tabFrame->AddTab("Results");
      resultsFrame->SetLayoutManager(new TGVerticalLayout(resultsFrame));                       
    tabFrame->SetTab(0);  
  vframe2->AddFrame(tabFrame, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX | kLHintsExpandY,2,2,2,2));   
  vframe2->Resize(tabFrame->GetDefaultWidth(), vframe1->GetDefaultHeight());
  this->AddFrame(vframe2,new TGLayoutHints(kLHintsRight|kLHintsExpandX|kLHintsExpandY));
  
  this->MapSubwindows();
  this->Layout();
  
}  

TZMdiFrame::~TZMdiFrame()
{
   this->Cleanup();
}

TGListTree * TZMdiFrame::FillTree(TGCanvas *fGCanvas)	{
    TGListTree *fGListTree = new TGListTree(fGCanvas,kHorizontalFrame);
    fGListTree->Connect("Clicked(TGListTreeItem*, Int_t, Int_t, Int_t)","TZMdiFrame",this,
              "HandleTreeClicked(TGListTreeItem* , Int_t , Int_t , Int_t )");
    fGListTree->Connect("DoubleClicked(TGListTreeItem*, Int_t, Int_t, Int_t)","TZMdiFrame",this,
              "HandleTreeDoubleClicked(TGListTreeItem* , Int_t , Int_t , Int_t )");

								
   const TGPicture *popen;       //used for list tree items
   const TGPicture *pclose;      //used for list tree items

   popen = gClient->GetPicture("ofolder_t.xpm");
   pclose = gClient->GetPicture("folder_t.xpm");
   
   TGListTreeItem *item0 = fGListTree->AddItem(NULL,"Entry 1");
   item0->SetPictures(popen, pclose);
   fGListTree->CloseItem(item0);
   TGListTreeItem *item1 = fGListTree->AddItem(NULL,"Entry 2");
   item1->SetPictures(popen, pclose);
   fGListTree->CloseItem(item1);
   fGListTree->SetSelected(item1);
   TGListTreeItem *item2 = fGListTree->AddItem(NULL,"Entry 3");
   item2->SetPictures(popen, pclose);
   fGListTree->CloseItem(item2);
   TGListTreeItem *item3 = fGListTree->AddItem(NULL,"Entry 4");
   item3->SetPictures(popen, pclose);
   fGListTree->CloseItem(item3);
   TGListTreeItem *item4 = fGListTree->AddItem(NULL,"Entry 5");
   item4->SetPictures(popen, pclose);
   fGListTree->CloseItem(item4);
		
   return fGListTree;
}

void TZMdiFrame::HandleTreeDoubleClicked(TGListTreeItem* entry, Int_t btn, Int_t x, Int_t y) {
	   char btn_str[100];
	   sprintf(btn_str,"Double click at:%s Button=%d x=%d y=%d",entry->GetText(),btn,x,y);
     this->fStatusBar->SetText(btn_str,0);
}	

void TZMdiFrame::HandleTreeClicked(TGListTreeItem* entry, Int_t btn, Int_t x, Int_t y) {
	   //btn=1 for left click btn=3 for right click
	   char btn_str[100];
	   sprintf(btn_str,"%s Button=%d x=%d y=%d",entry->GetText(),btn,x,y);
     this->fStatusBar->SetText(btn_str,0);
     if (btn == 3) this->fMenuEdit->PlaceMenu(x,y,false,true);
}	


void TZMdiFrame::CreateMenuEdit(){
	fMenuEdit = new TGPopupMenu(gClient->GetRoot());
  //fMenuEdit->Connect("Activated(Int_t)", "TZMdiFrame", this, "HandleMenu(Int_t)");
	fMenuEdit->AddEntry("Undo",M_EDIT_UNDO);
  fMenuEdit->AddSeparator(); 	
  fMenuEdit->AddEntry("Cut",M_EDIT_CUT);
  fMenuEdit->AddEntry("Copy",M_EDIT_COPY);
  fMenuEdit->AddEntry("Paste",M_EDIT_PASTE);
  fMenuEdit->AddSeparator();    
  fMenuEdit->AddEntry("Find",M_EDIT_FIND);
  fMenuEdit->AddEntry("Find Next",M_EDIT_FINDNEXT);
  fMenuEdit->AddEntry("Replace",M_EDIT_REPLACE);
}


